Ext.define('DSS.component.ActionConfigurator', {
    extend : 'DSS.component.Base',
    mixins : {
        observable : 'Ext.util.Observable'
    },
    height : '100%',
    layout : 'border',
    selectedElement : null,
    gridStore : null,
    grids : {},
    mainGrid : null,
    macPanel : null,
    lblSelectorAnzeige : null,
    iDefaultWidth : 150,
    iDefaultHeight : 293,
    oButtonNew : null,
    oButtonEdit : null,
    oButtonUp : null,
    oButtonDown : null,
    oButtonDelete : null,
    oActualValue : null,
    fDelayEnabled: false,
    fAllowNoAction: false,
    fEnableUsergroup: false,
    fHighLevel:true,
    fIgnorePresence:false,
    fHeatingOperationMode:false,
    compileToUDA: function () {
    	
    },
    updatePanelDescription: function() {
    	this.fireEvent('updatePanelDescription');
    },
    _updatePanelDescription: function() {
    	var sStringTitle=(_('edit activity: ') + _('incomplete activity'));
    	if (this.oActualValue==null) {
        	sStringTitle=(_('edit activity: ') + _('incomplete activity'));
        } else {
            switch (this.oActualValue.type) {
                case 'zone-scene': { // scene, group,zone,force
                    var sString = "";

                    if (this.oActualValue.params.force)
                        sString += _('all ');
                    
                    sString += dss.staticDataModel.getNameForScene(this.oActualValue.params.zone, this.oActualValue.params.group, this.oActualValue.params.scene);
                    
                    if (this.oActualValue.params.group != 0)
                        sString += _(' for ') + dss.staticDataModel.getNameForGroup(this.oActualValue.params.zone, this.oActualValue.params.group);
                    if (this.oActualValue.params.zone != 0)
                        sString += _(' in ') + dss.staticDataModel.getNameForZone(this.oActualValue.params.zone);
                    else
                        if (this.oActualValue.params.scene < 64)
                        	if (!((this.oActualValue.params.group >15) && (this.oActualValue.params.group <24)))
                        		sString += _(' in all rooms');
                    sStringTitle=(_('edit activity: ') + sString);
                    
                    break;
                }
                case 'undo-zone-scene': { // scene, group,zone,force
                    var sString = _("Undo ");

                    if (this.oActualValue.params.force)
                        sString += _('all ');
                    
                    sString += dss.staticDataModel.getNameForScene(this.oActualValue.params.zone, this.oActualValue.params.group, this.oActualValue.params.scene);
                    
                    if (this.oActualValue.params.group != 0)
                        sString += _(' for ') + dss.staticDataModel.getNameForGroup(this.oActualValue.params.zone, this.oActualValue.params.group);
                    if (this.oActualValue.params.zone != 0)
                        sString += _(' in ') + dss.staticDataModel.getNameForZone(this.oActualValue.params.zone);
                    else
                        if (this.oActualValue.params.scene < 64)
                            sString += _(' in all rooms');
                    sStringTitle=(_('edit activity: ') + sString);
                    
                    break;
                }
                case 'device-scene': {// scene, dsuid,force
                    var oDevice = dss.staticDataModel.getDevice(this.oActualValue.params.dsuid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                    if (this.oActualValue.params.scene == 13) {// aus
                        sString = sString + _(' turn off');
                    } else if (this.oActualValue.params.scene == 14) {// ein
                        sString = sString + _(' turn on');
                    } else if (this.oActualValue.scene == 51) { // ein loc
                        sString = sString + _(' turn local on');
                    } else {                        
                        sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, this.oActualValue.params.scene) + _(' for ') + sString;
                        if (this.oActualValue.params.force)
                            sString = _('all ') + sString;
                    }
                    sStringTitle=(_('edit activity: ') + sString);

                    break;
                }
                case 'device-value': { // value, dsuid
                	sStringTitle=('<span style="color:#ff0000;">'+_('The activity is not longer supported. Please choose a other activity or delete it')+'</span>');
                    break;
                }
                case 'zone-value': { // value, dsuid
                	sStringTitle=('<span style="color:#ff0000;">'+_('The activity is not longer supported. Please choose a other activity or delete it')+'</span>');
                    break;
                }
                case 'device-blink': {// dsuid
                    var oDevice = dss.staticDataModel.getDevice(this.oActualValue.params.dsuid);
                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += _(' blinking');
                    sStringTitle=(_('edit activity: ') + sString);
                    break;
                }
                case 'zone-blink': {// group,zone
                    var sString = dss.staticDataModel.getNameForGroup(this.oActualValue.params.zone, this.oActualValue.params.group);
                    if (this.oActualValue.params.zone!=0)
                        sString +=_(' in ')+  dss.staticDataModel.getNameForZone(this.oActualValue.params.zone);
                    else
                        sString += _(' in all rooms');
                    sString += _(' blinking');
                    sStringTitle=(_('edit activity: ') + sString);
                    break;
                }
                case 'custom-event': { // event
                	sStringTitle=(_('edit activity: ') + _('action')+ ' ' + dss.staticDataModel.getHLENameFromId(this.oActualValue.params.event));
                    break;
                }
                case 'url': { // url
                	sStringTitle=(_('edit activity: ') + 'URL: ' + unescape(this.oActualValue.params.url));
                    break;
                }
                default: 
                	sStringTitle=(_('edit activity: ') + _('incomplete activity'));
            }
        }      
        this.macPanel.setTitle(sStringTitle);
    },
    setHeight : function(oHeight) {
        this.macPanel.setHeight(oHeight - 30);
        this.iDefaultHeight = oHeight - 57;
        for ( var oKey in this.grids)
            this.grids[oKey].setHeight(this.iDefaultHeight);
        this.callParent(arguments);
    },
    defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
        if (record.get('name') == '-') {
        	return '<table style="height:16px;width:100%;"><tr style="height:16px;"><td width="100%"><hr></td></tr></table>';
        } 
        var fHasIcon=false;
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
        var fHasNext=false;
        if (record.get('next') == true)  // definition erfordert weiterbutton
        {
            fHasNext=true;
        }
        if (record.get('group') != null)   // ist eine gruppe -> weiterbutton
        {
            fHasNext=true;
        }
        if ((record.get('dSID') != null) || (record.get('dSUID') != null))    // ist ein device -> weiterbutton
        {
            fHasNext=true;
        }
        var fIsCheckable=false;
        if (record.get('checkable') != null) 
            if (record.get('checkable')) {
                fHasNext=false; // checkboxen niemals weiterbuttons
                fHasIcon=false; // keine Icons nach Checkboxen
                fIsCheckable=true;
            }

        var fIsPassive=false;        
        if (record.get('passive')!=null)
            if (record.get('passive'))
                fIsPassive=true;
        if (fIsPassive) {
            fHasNext=false;               // spalte disabled -> niemals weiterbutton
            fIsChecked=false;             // spalte disabled -> kann nicht gechecked sein
        }

        var sReturn='<table style="height:16px;width:100%;"><tr>';
        var iColspaceCounter=3;
        if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
        if (fIsCheckable)
        {
            iColspaceCounter--;  
            if (record.get('checked') == true)
            {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" /></td>';
            } else {
                sReturn+='<td style="padding-right: 5px;"><div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" /></td>';
            }
        }
        if (fHasNext)
            iColspaceCounter--;
        if (fIsPassive) {
            sReturn+='<td style="color:#888888;" colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        } else {
            sReturn+='<td colspan="'+iColspaceCounter+'" width="100%">' + record.get('name') + '</td>';
        }
        if (fHasNext) {
            sReturn+='<td>&gt;</td>';
        }
        return sReturn +'</tr></table>';  

    },
    defMainGridRenderer : function(val, metadata, record, colIdx, store, view) {
        var oAction = record.get('action');
        oAction.params.type=oAction.type;
        var fValid= dss.validateActionObject(oAction.params);
        var sError="";
        if (fValid==dss.validValue.completlyWrong)
            sError="color:#ff0000;";
        if (fValid==dss.validValue.temporaryWrong)
            sError="color:#aaaaaa;";
        
        switch (oAction.type) {
        	case 'change-addon-state': {
        		if (oAction.params['addon-id']=="user-defined-states") {
        			var idString =oAction.params.statename.split('_')[1];
        			
        			var oUserStates=dss.staticDataModel.getUserStates();
        			var sStringValue;
        			for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
            			if (oUserStates[iIndex].id==idString) {
            				if (oAction.params.state=='active')
            					sStringValue=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[iIndex].name)});
            				else
            					sStringValue=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[iIndex].name)});
            			}
            		}
        			
	        		var sString = '<table><tr><td style="'+sError+'padding-right:5px;"></td>';   
	        		sString += '<td style="'+sError+'">' +  sStringValue;
	        		sString += "</td></tr></table>";
	        		return sString;
        		} 
        		break;
        	}
        	case 'change-state' : {
        		var sString = '<table><tr><td style="'+sError+'padding-right:5px;">' + 
    			'<img src="'+dss.staticDataModel.getImagePathForState(oAction.params.statename, oAction.params.state) + '"></td>';   
        		sString += '<td style="'+sError+'">' +  dss.staticDataModel.getNameForState(oAction.params.statename, oAction.params.state);
        		sString += "</td></tr></table>";
        		return sString;
        		break;
        	}      
        	case 'heating-mode' : {

                var sString = '<table><tr><td style="padding-right:5px;height:16px;'+sError+'">' + dss.staticDataModel.getImageForScene(oAction.params.zone, 48, oAction.params.mode) + "</td>";
                
                sString += '<td style="'+sError+'">';
                if (oAction.params.reset==true)
                	sString+=_('Reset ');
                sString += dss.staticDataModel.getNameForScene(oAction.params.zone, 48, oAction.params.mode);
                if (oAction.params.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oAction.params.zone, 48);
                
                if (oAction.params.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oAction.params.zone);
                else
                    if (oAction.params.mode < 64)
                        sString += _(' in all rooms');

                sString += "</td></tr></table>";
                return sString;       		
        	}
            case 'zone-scene': { // scene, group,zone,force    
            	            	
                var sString = '<table><tr><td style="padding-right:5px;height:16px;'+sError+'">' + dss.staticDataModel.getImageForScene(oAction.params.zone, oAction.params.group, oAction.params.scene) + "</td>";
                
                sString += '<td style="'+sError+'">';
                if (oAction.params.force)
                    sString += _('all ');

                sString += dss.staticDataModel.getNameForScene(oAction.params.zone, oAction.params.group, oAction.params.scene);
                if (oAction.params.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
                
                if (oAction.params.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oAction.params.zone);
                else
                    if (oAction.params.scene < 64)
                        sString += _(' in all rooms');

                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'undo-zone-scene': { // scene, group,zone,force                
                var sString = '<table><tr><td style="padding-right:5px;height:16px;'+sError+'">' + dss.staticDataModel.getImageForScene(oAction.params.zone, oAction.params.group, oAction.params.scene,true) + "</td>";
                
                sString += '<td style="'+sError+'">';
                if (oAction.params.force)
                    sString += _('all ');

                sString += _('Undo ') + dss.staticDataModel.getNameForScene(oAction.params.zone, oAction.params.group, oAction.params.scene);
                if (oAction.params.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
                
                if (oAction.params.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oAction.params.zone);
                else
                    if (oAction.params.scene < 64)
                        sString += _(' in all rooms');

                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'zone-value': { // value, dsuid
                var sString = '<table><tr><td style="'+sError+'height:16px;">' + Math.round(oAction.params.value / 2.55) + "%" + _(' for ');
                if (oAction.params.group != 0)
                    sString += _(' for ') + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
                if (oAction.params.zone != 0)
                    sString += _(' in ') + dss.staticDataModel.getNameForZone(oAction.params.zone);
                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'device-scene': {// scene, dsuid,force
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsuid);

                var sString = oDevice.name + _(' in ');
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                if (oAction.params.scene == 13) {// aus
                    sString = '<table><tr><td style="padding-right:5px;height:16px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString +  _(' turn off')+"</td></tr></table>";
                } else if (oAction.params.scene == 14) {// ein
                    sString = '<table><tr><td style="padding-right:5px;height:16px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString + _(' turn on')+"</td></tr></table>";
                } else if (oAction.params.scene == 51) { // ein loc
                    sString = '<table><tr><td style="padding-right:5px;height:16px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td style="'+sError+'">' + sString +  _(' turn on')+ "</td></tr></table>";
                } else {
                    sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, oAction.params.scene) + _(' for ') + sString+ "</td></tr></table>";
                    if (oAction.params.force)
                        sString =  _('all ') + sString;
                    sString = '<table><tr><td style="padding-right:5px;height:16px;'+sError+'">'
                            + dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID, oAction.params.scene) + '</td><td style="'+sError+'">' + sString;
                }
                return sString;
                break;
            }
            case 'device-value': { // value, dsuid
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsuid);
                var sString = '<table><tr><td style="'+sError+'height:16px;">' + Math.round(oAction.params.value / 2.55) + "%" + _(' for ');
                sString += oDevice.name + _(' in ');
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                sString += "</td></tr></table>";
                return sString;
                break;
            }
            case 'device-blink': {// dsuid
                var oDevice = dss.staticDataModel.getDevice(oAction.params.dsuid);
                var sString = '<table><tr><td style="'+sError+'padding-right:5px;height:16px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                sString += '<td style="'+sError+'">' + oDevice.name + _(' in ');
                sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                sString += _(' blinking')+"</td></tr></table>";
                return sString;
                break;
            }
            case 'zone-blink': {// group,zone
                var sString = '<table><tr><td style="'+sError+'padding-right:5px;height:16px;"><img src="' + dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png"></td>';
                sString += '<td style="'+sError+'">' + dss.staticDataModel.getNameForGroup(oAction.params.zone, oAction.params.group);
                if (oAction.params.zone!=0)
                    sString += " in " + dss.staticDataModel.getNameForZone(oAction.params.zone);                
                else
                    if (oAction.params.scene < 64)
                        sString +=  _(' in all rooms');

                sString += _(' blinking')+"</td></tr></table>";
                return sString;
                break;
            }
            case 'custom-event': { // event
                return '<span style="'+sError+'">'+ _('action') +': ' + dss.staticDataModel.getHLENameFromId(oAction.params.event) + '</span>'; 
                break;
            }
            case 'url': { // url
                return  '<span style="'+sError+'">URL: ' + oAction.params.url + '</span>'; 
                break;
            }
            default: {
                return '<span style="color:#ff0000;">' + _('incomplete activity') + '</span>';
                break;
            }
        }
    },
    initStores : function(fHiglevelShown,fUserstateShown) {
    	
    	if (Ext.data.StoreManager.lookup('actionConfigurator_userStateStore') == null) {
    		
    		Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_userStateStore',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            
    		var oUserStates=dss.staticDataModel.getUserStates();
    		
    		for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
       		 var sActiveName=Ext.String.format2(_('{state} is active'),{state:unescape(oUserStates[iIndex].name)});
    		 var sPassiveName=Ext.String.format2(_('{state} is inactive'),{state:unescape(oUserStates[iIndex].name)});
    			var Aktionen = [{
                    name : sActiveName,
                    id : oUserStates[iIndex].id + '_active',
                    next : false,
                    icon : null
                },{
                	name : sPassiveName,
                    id : oUserStates[iIndex].id + '_inactive',
                    next : false,
                    icon : null
                }];
    			Ext.data.StoreManager.lookup('actionConfigurator_userStateStore').add(Aktionen);
    		}
            

    	}
    	
        if (Ext.data.StoreManager.lookup('actionConfigurator_accessStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 73),
                id : 73,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 73)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 72),
                id : 72,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 72)
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 71),
                id : 71,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 71)
            } ];
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_accessStore',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('actionConfigurator_accessStore').add(Aktionen);
        }
        
        if (Ext.data.StoreManager.lookup('actionConfigurator_weatherStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForState('rain', 'active'),
                id : 'rain_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('rain', 'inactive'),
                id : 'rain_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('rain', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'active'),
                id : 'wind_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('wind', 'inactive'),
                id : 'wind_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('wind', 'inactive')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'active'),
                id : 'hail_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('hail', 'inactive'),
                id : 'hail_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('hail', 'inactive')
            }];
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_weatherStore',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('actionConfigurator_weatherStore').add(Aktionen);
        }
        
        if (Ext.data.StoreManager.lookup('actionConfigurator_securityStore') == null) {
            var Aktionen = [{
                name : dss.staticDataModel.getNameForScene(0, 0, 65),
                id : 65,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 65),
                id : 1065,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 65,true)
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'active'),
                id : 'fire_active',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'active')
            },{
            	name : dss.staticDataModel.getNameForState('fire', 'inactive'),
                id : 'fire_inactive',
                next : false,
                icon : dss.staticDataModel.getImagePathForState('fire', 'inactive')
            }, {
                name : dss.staticDataModel.getNameForScene(0, 0, 74),
                id : 74,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 74),
                id : 1074,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 74,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 83),
                id : 83,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 83),
                id : 1083,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 83,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 84),
                id : 84,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 84),
                id : 1084,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 84,true)
            },{
                name : dss.staticDataModel.getNameForScene(0, 0, 85),
                id : 85,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85)
            }, {
                name : _('Undo ') + dss.staticDataModel.getNameForScene(0, 0, 85),
                id : 1085,
                next : false,
                icon : dss.staticDataModel.getImagePathForScene(0, 0, 85,true)
            }];
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_securityStore',
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('actionConfigurator_securityStore').add(Aktionen);
        }
    	
        if (Ext.data.StoreManager.lookup('actionConfigurator_l1Store') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_l1Store',
                fields : [ 'id', 'name', 'next', 'icon','passive' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var Aktionen = [ {
                name : _('activity in room'),
                id : 0,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }];
            Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add(Aktionen);

            if (this.fEnableUsergroup) {
                Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add( [{
                    name : _('usergroup'),
                    id : 7,
                    next : true,
                    icon : null,
                    passive: (dss.staticDataModel.getUsergroups().length==0)
                }]);
            }
            
            Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add( [{
                name : _('single device'),
                id : 1,
                next : true,
                icon : null,
                passive: (dss.staticDataModel.getZoneArray().length==1)
            }]);
            
            if (fHiglevelShown) {
                Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add( [{
                    name : _('user def. actions'),
                    id : 2,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getHLE().length==0)
                }]);
            }
            Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add([{
                name : _('call URL'),
                id : 3,
                next : true,
                icon : null
            }, {
                name : '-',
                id : -1,
                next : false,
                icon : null,
                passive:true
            }, {
                name : _("access action"),
                id : 4,
                next : true,
                icon : null
            }, {
                name : _('weather action'),
                id : 5,
                next : true,
                icon : null
            }, {
                name : _('security action'),
                id : 6,
                next : true,
                icon : null
            }]);
                        
            if (fUserstateShown) {
                Ext.data.StoreManager.lookup('actionConfigurator_l1Store').add( [{
                    name : _('user states'),
                    id : 8,
                    next : true,
                    icon : null,
                    passive:(dss.staticDataModel.getUserStates().length==0)
                }]);
            }
        }
        if (Ext.data.StoreManager.lookup('actionConfigurator_zoneStore') == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_zoneStore',
                fields : [ 'ZoneID', 'name' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            Ext.data.StoreManager.lookup('actionConfigurator_zoneStore').add(dss.staticDataModel.getZoneArray());
        }
    },
    initGridStore : function() {
        var me = this;
        this.gridStore = Ext.create('Ext.data.Store', {

            fields : [ 'pos', 'action' , 'delay'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            },
            listeners : {
                datachanged : function(store, eOpts) {
                    if (store.getCount()==0)
                        me.lblSelectorAnzeige.setText( _('no activity'),false);
                    else if (store.getCount()==1)
                        me.lblSelectorAnzeige.setText(_('1 activity'),false);
                    else
                        me.lblSelectorAnzeige.setText('' + store.getCount() + _(' activites'),false);
                }
            }
        });
    },
    getGroupStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_groupStore_' + ZoneID,
                fields : [ 'group', 'name', 'icon', 'reachable' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oGroup = dss.staticDataModel.getGroupForZone(ZoneID);
            Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID).add(oGroup);
            
            if (dss.staticDataModel.heating[ZoneID].receiveOperationMode==true) {
            	Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID).add({
            		group:48,
            		name:_('Heating Modes'),
            		icon:dss.staticDataModel.getImagePathForGroup(0,3),
            		reachable:true
            	});                	
            }
            
        }
        return Ext.data.StoreManager.lookup('actionConfigurator_groupStore_' + ZoneID);
    },
    getSceneStore : function(ZoneID, groupID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_szeneStore_' + ZoneID + '_' + groupID,
                fields : [ 'id', 'name', 'reachable', 'icon', 'outputMode' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            if (groupID==48) {
            	if (ZoneID==0) {
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:4,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('NIGHT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:5,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('HOLIDAY Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:-1,
                		reachable:true,
                		icon:null,
                		name:'-'
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:4+32,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset NIGHT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:5+32,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset HOLIDAY Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:-1,
                		reachable:false,
                		icon:null,
                		name:'-'
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:1,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,5,false),
                		name:_('ECO Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:2,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,5,false),
                		name:_('COMFORT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:3,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('NotUsed Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:-1,
                		reachable:false,
                		icon:null,
                		name:'-'
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:3+32,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset NotUsed Mode')
                	});
            	} else {
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:1,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,5,false),
                		name:_('ECO Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:2,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,5,false),
                		name:_('COMFORT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:3,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('NotUsed Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:-1,
                		reachable:true,
                		icon:null,
                		name:'-'
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:3+32,
                		reachable:true,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset NotUsed Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:4,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('NIGHT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:5,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('HOLIDAY Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:-1,
                		reachable:false,
                		icon:null,
                		name:'-'
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:4+32,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset NIGHT Mode')
                	});
                	Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add( {
                		id:5+32,
                		reachable:false,
                		icon:dss.staticDataModel.getImagePathForScene(0,3,0,false),
                		name:_('reset HOLIDAY Mode')
                	});
            	}
            } else { 
            var oScenes = dss.staticDataModel.getScenes(ZoneID, groupID);
            for ( var iIndex = 0; iIndex < oScenes.length; iIndex++) {
                var oObject = {};
                oObject.id = oScenes[iIndex].id;
                oObject.reachable = oScenes[iIndex].reachable;
                oObject.icon = oScenes[iIndex].icon;
                if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                    oObject.name = oScenes[iIndex].name;
                else
                    oObject.name = oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                
                if (oObject.undoable) {
                    oObject = {};
                    oObject.id = -1 * oScenes[iIndex].id;
                    oObject.reachable = oScenes[iIndex].reachable;
                    oObject.icon = oScenes[iIndex].icon;
                    if (oScenes[iIndex].name == oScenes[iIndex].defaultName)
                        oObject.name = _('Undo ') + oScenes[iIndex].name;
                    else
                        oObject.name = _('Undo ') + oScenes[iIndex].defaultName + ' - ' + oScenes[iIndex].name;
                    Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID).add(oObject);
                }
                
            }}

        }
        return Ext.data.StoreManager.lookup('actionConfigurator_szeneStore_' + ZoneID + '_' + groupID);

    },
    getDeviceStore : function(ZoneID) {
        if (Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID) == null) {
            Ext.create('Ext.data.Store', {
                storeId : 'actionConfigurator_deviceStore_' + ZoneID,
                fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present', 'outputMode' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            var oDevice = dss.staticDataModel.getDevicesForZone(ZoneID, 0);
            for (var iIndex=0;iIndex<oDevice.length;iIndex++) {
            	if (oDevice[iIndex].outputMode!=0)
                    Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID).add(oDevice[iIndex]);
            }
        }
        return Ext.data.StoreManager.lookup('actionConfigurator_deviceStore_' + ZoneID);
    },
    constructGridLvlUserGroup : function() {
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroups=dss.staticDataModel.getUsergroups();
        for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
            oGroupControlStore.add({
                id : oGroups[iIndex].id,
                group : oGroups[iIndex].id,
                name : oGroups[iIndex].name,
                icon : dss.staticDataModel.getImagePathForGroup(0,oGroups[iIndex].id),
                reachable : true
            });
            if (oGroups[iIndex].color == 1)
                oGroupControlStore.add({
                    id : -1 * oGroups[iIndex].id,
                    group : null,
                    name : oGroups[iIndex].name + _(' blinking'),
                    icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                    reachable : true
                });
        }

        this.grids.lvlUserGroup = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlUserGroup.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.grids.lvlUserGroup.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlUsergroupScene);
            if (record.get('id')!=null) {
                if (record.get('id') < 0) {
                    var oObject = {
                        type : 'zone-blink',
                        params : {
                            zone : 0,
                            group : Math.abs(record.get('id'))
                        }
                    };                            
                    this.parent.setSelectedSubItem(oObject,true);                            
                } else
                	this.parent.constructGridLvlUserGroupScene(record.get('id'));
            }
        });


        this.grids.lvlUserGroup.parent = this;
        this.macPanel.add(this.grids.lvlUserGroup);
    },
    constructGridLvlUserGroupScene : function(groupID, fAll, fForce) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false;
        var oSceneStore = this.getSceneStore(0, groupID);
        oSceneControlStore.add({
            id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll) {
                if (oNewRecord.get('id') < 64) {
                    oSceneControlStore.add(oNewRecord);
                    if (oNewRecord.get('id')==0) {
                        if (groupID==2) {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all closed'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });                            
                        } else {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all off'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });
                        }
                    }
                }
            }
        });

        this.grids.lvlUsergroupScene = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 474,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlUsergroupScene.parent = this;
        this.grids.lvlUsergroupScene.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });                       
                        grid.store.add({
                            id : -1,
                            name : '-',
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64) {
                                    grid.store.add(oNewRecord);
                                    if (oNewRecord.get('id')==0) {
                                        if (groupID==2) {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:_('all closed'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        } else {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:_('all off'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        }
                                    }
                                }
                        });

                    }
                }
            }
            if (record.get('id')>=0) {                       
                var groupID = this.parent.grids.lvlUserGroup.getSelectionModel().getSelection()[0].get('id');
                if (groupID != null) {
                    var fForce = false;
                    if (record.get('force')!=null)
                        fForce=record.get('force');
                    var oObject = {
                        type : 'zone-scene',
                        params : {
                            zone : 0,
                            group : groupID,
                            scene : record.get('id'),
                            force : fForce
                        }
                    };
                    this.parent.setSelectedSubItem(oObject,true);
                }
            }
        });
        this.grids.lvlUsergroupScene.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlUsergroupScene);

    },
    constructGridLvlAccess : function() {
    	var me=this;
        this.grids.lvlAccess = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },            
            store : Ext.data.StoreManager.lookup('actionConfigurator_accessStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlAccess.parent = this;
        this.grids.lvlAccess.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
                           
            if (record.get('id')<1000) {               
                var oObject = {
                    type : 'zone-scene',
                    params : {
                        zone : 0,
                        group : 0,
                        scene : record.get('id'),
                        force : false
                    }
                };
                this.parent.setSelectedSubItem(oObject,true);
            } else {
                var oObject = {
                    type : 'undo-zone-scene',
                    params : {
                        zone : 0,
                        group : 0,
                        scene : record.get('id')-1000,
                        force : false
                    }
                };
                this.parent.setSelectedSubItem(oObject,true);
            }
        });
        this.grids.lvlAccess.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlAccess);

    },
    constructGridLvlUserState: function (){
    	this.grids.lvlUserState = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },          
            store : Ext.data.StoreManager.lookup('actionConfigurator_userStateStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('userState'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlUserState.parent = this;
        this.grids.lvlUserState.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;

        	var sValue=record.get('id');
        	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
        	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
        	var oObject = {
                    type : 'change-addon-state',
                    params: {
	                    statename : 'uds_' +stateName,
	                    addonId: 'user-defined-states',
	                    state : stateValue
                    }
                };
        	this.parent.setSelectedSubItem(oObject,true);           
        });
        this.grids.lvlUserState.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlUserState);

    },    
    constructGridLvlWeather : function() {
        this.grids.lvlWeather = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },          
            store : Ext.data.StoreManager.lookup('actionConfigurator_weatherStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlWeather.parent = this;
        this.grids.lvlWeather.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;

        	var sValue=record.get('id');
        	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
        	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
        	var oObject = {
                    type : 'change-state',
                    params: {
	                    statename : stateName,
	                    state : stateValue
                    }
                };
        	this.parent.setSelectedSubItem(oObject,true);           
        });
        this.grids.lvlWeather.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlWeather);
    },
    constructGridLvlPanic : function() {
    	
        this.grids.lvlPanic = Ext.create('Ext.grid.Panel', {
            hideHeaders:true,
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : Ext.data.StoreManager.lookup('actionConfigurator_securityStore'),
            columns : [ {
                sortable : false,
                hideable : false,
                text : _('scene'),
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });

        this.grids.lvlPanic.parent = this;
        this.grids.lvlPanic.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            
        	if ((""+record.get('id')).indexOf('_')>=0) {
            	var sValue=record.get('id');
            	var stateName=sValue.substr(0,sValue.lastIndexOf('_'));
            	var stateValue=sValue.substr(sValue.lastIndexOf('_')+1);
            	var oObject = {
                        type : 'change-state',
                        params: {
                        	statename : stateName,
                        	state : stateValue
                        }
                    };
            	this.parent.setSelectedSubItem(oObject,true);                    	
        	} else 
            
            
            if (record.get('id')<1000) {               
                var oObject = {
                    type : 'zone-scene',
                    params : {
                        zone : 0,
                        group : 0,
                        scene : record.get('id'),
                        force : false
                    }
                };
                this.parent.setSelectedSubItem(oObject,true);
            } else {
                var oObject = {
                    type : 'undo-zone-scene',
                    params : {
                        zone : 0,
                        group : 0,
                        scene : record.get('id')-1000,
                        force : false
                    }
                };
                this.parent.setSelectedSubItem(oObject,true);
            }
        });
        this.grids.lvlPanic.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlPanic);
    },
    constructGridLvlDeviceScene : function(zoneID, groupID, fAll, fForce) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false;

        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll
        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            icon : null,
            reachable : true,
            passive:true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll)
                if (oNewRecord.get('id') < 64) {
                    oSceneControlStore.add(oNewRecord);
                    if (oNewRecord.get('id')==0) {
                        if (groupID==2) {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all closed'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });
                        } else {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all off'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });
                        }
                    }
                }
        });

        this.grids.lvlDeviceScene = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 174,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            hideHeaders:true,
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceScene.parent = this;
        this.macPanel.add(this.grids.lvlDeviceScene);

        this.grids.lvlDeviceScene.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });
                        grid.store.add({
                            id : -1,
                            name : '-',
                            icon : null,
                            reachable : true,
                            passive:true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64) {
                                    grid.store.add(oNewRecord);
                                    if (oNewRecord.get('id')==0) {
                                        if (groupID==2) {
                                            grid.store.add({
                                                id:0,
                                                name:_('all closed'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        } else {
                                            grid.store.add({
                                                id:0,
                                                name:_('all off'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        }
                                    }
                                }
                        });

                    }
                    return;
                }
            }
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                var dSUID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSUID');
                if (dSUID != null) {
                    var fForce = false;
                    if (record.get('force')!=null)
                        fForce=record.get('force');
                    var oObject = {
                        type : 'device-scene',
                        params : {
                            dsuid : dSUID,
                            scene : record.get('id'),
                            force : fForce
                        }
                    };
                    this.parent.setSelectedSubItem(oObject,true);
                }
            }
        });
        this.grids.lvlDeviceScene.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

    },
    constructGridLvlDeviceActions : function(dSUID) {
        var oDeviceActionControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'next' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var oDeviceObject = dss.staticDataModel.getDevice(dSUID);
        if ((oDeviceObject.GroupID == 1)||
                (oDeviceObject.buttonActiveGroup != 8))  {
            var iGroup=oDeviceObject.GroupID;
            if (iGroup==8)
                iGroup=oDeviceObject.buttonActiveGroup;
            
            if (oDeviceObject.functionID!=28688) {            
	            oDeviceActionControlStore.add({
	                id : 5,
	                name : _('call scene'),
	                icon : null,
	                next : true
	            });
	            oDeviceActionControlStore.add({
	                id : 1,
	                name : (oDeviceObject.GroupID==2)?_('Close'):_('Turn off'),
	                icon : dss.staticDataModel.getImagePathForScene(0, iGroup, 0),
	                next : false
	            });
	            oDeviceActionControlStore.add({
	                id : 2,
	                name : (oDeviceObject.GroupID==2)?_('Open'): _('Turn on'),
	                icon : dss.staticDataModel.getImagePathForScene(0, iGroup, 5),
	                next : false
	            }); 
            }
            /*
            oDeviceActionControlStore.add({
                id : 3,
                name : 'Einschalten mit Lokalpriorit&auml;t',
                icon : dss.staticDataModel.getImagePathForScene(0, 1, 5),
                next : false
            });*/
            oDeviceActionControlStore.add({
                id : 4,
                name : _('Blink'),
                icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                next : false
            });
        } else if (oDeviceObject.GroupID == 8) {
            oDeviceActionControlStore.add({
                id : 1,
                name : _('Turn off'),
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 0),
                next : false
            });
            oDeviceActionControlStore.add({
                id : 2,
                name : _('Turn on'),
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 5),
                next : false
            });
        } else {
            oDeviceActionControlStore.add({
                id : 5,
                name :  _('call scene'),
                icon : null,
                next : true
            });                  
            oDeviceActionControlStore.add({
                id : 1,
                name : (oDeviceObject.GroupID==2)?_('Close'):_('Turn off'),
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 0),
                next : false
            });
            oDeviceActionControlStore.add({
                id : 2,
                name : (oDeviceObject.GroupID==2)?_('Open'): _('Turn on'),
                icon : dss.staticDataModel.getImagePathForScene(0, oDeviceObject.GroupID, 5),
                next : false
            }); /*
            oDeviceActionControlStore.add({
                id : 3,
                name : 'Einschalten mit Lokalpriorit&auml;t',
                icon : dss.staticDataModel.getImagePathForScene(0, 1, 5),
                next : false
            });*/
            
            oDeviceActionControlStore.add({
                id : 4,
                name : _('Blink'),
                icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                next : false
            });
        }

        this.grids.lvlDeviceAction = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            hideHeaders:true,
            store : oDeviceActionControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDeviceAction.parent = this;

        this.grids.lvlDeviceAction.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            var id = record.get('id');
            if (id == 5) {
                var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                var dSUID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSUID');
                var oDeviceObject = dss.staticDataModel.getDevice(dSUID);
                var iGroup=oDeviceObject.GroupID;                
                if (iGroup==8)
                    iGroup=oDeviceObject.buttonGroupMembership;
                this.parent.constructGridLvlDeviceScene(oDeviceObject.ZoneID, iGroup);
            } else {
                if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                    var dSID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSID');
                    var dSUID = this.parent.grids.lvlDevice.getSelectionModel().getSelection()[0].get('dSUID');
                    if (dSUID != null) {
                        switch (id) {
                            case 1:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsuid : dSUID,
                                        scene : 13,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject,true);
                            break;
                            case 2:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsuid : dSUID,
                                        scene : 14,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject,true);
                            break;
                            case 3:
                                var oObject = {
                                    type : 'device-scene',
                                    params : {
                                        dsuid : dSUID,
                                        scene : 51,
                                        force : false
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject,true);
                            break;
                            case 4:
                                var oObject = {
                                    type : 'device-blink',
                                    params : {
                                        dsuid : dSUID
                                    }
                                };
                                this.parent.setSelectedSubItem(oObject,true);
                            break;
                        }

                    }
                }
            }
        });

        this.grids.lvlDeviceAction.on('itemdblclick', function(grid, record) {          
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlDeviceAction);

    },
    constructGridLvlDevice : function(zoneID) {
        var oDeviceControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'dSID', 'dSUID', 'name', 'icon', 'present' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        var me=this;
        var oDeviceStore = this.getDeviceStore(zoneID);
        oDeviceStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('present')||me.fIgnorePresence)
                if ((oNewRecord.get('outputMode') != 0) && (oNewRecord.get('outputMode') != 30) && (oNewRecord.get('outputMode') != 64))
                    oDeviceControlStore.add(oNewRecord);
        });
        oDeviceControlStore.sort('name');
        this.grids.lvlDevice = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oDeviceControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlDevice.parent = this;
        this.grids.lvlDevice.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            var dSID = record.get('dSID');
            var dSUID = record.get('dSUID');
            this.parent.constructGridLvlDeviceActions(dSUID);
        });
        this.macPanel.add(this.grids.lvlDevice);
    },
    constructGridLvlGroupScene : function(zoneID, groupID, fAll, fForce) {
        var oSceneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'name', 'icon', 'reachable', 'checkable', 'checked' ,'force'],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });
        if (fAll == null)
            fAll = false;
        if (fForce == null)
            fForce = false;
        var oSceneStore = this.getSceneStore(zoneID, groupID);
        oSceneControlStore.add({
            id : -3,
            name : _('show all scenes'),
            icon : null,
            reachable : true,
            checkable : true,
            checked : fAll

        });
        oSceneControlStore.add({
            id : -1,
            name : '-',
            icon : null,
            reachable : true
        });
        oSceneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable') || fAll) {
                if (oNewRecord.get('id') < 64) {
                    oSceneControlStore.add(oNewRecord);
                    if (oNewRecord.get('id')==0) {
                        if (groupID==2) {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all closed'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });                            
                        } else {
                            oSceneControlStore.add({
                                id:0,
                                name:_('all off'),
                                icon:oNewRecord.get('icon'),
                                force:true
                            });
                        }
                    }
                }
            }
        });

        this.grids.lvlScene = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 324,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oSceneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlScene.parent = this;
        this.grids.lvlScene.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            if (record.get('checkable') != null) {
                if (record.get('checkable')) {
                    var fChecked = !record.get('checked');
                    record.set('checked', fChecked);
                    grid.getSelectionModel().deselectAll();
                    if (record.get('id') == -3) {
                        // alle Stimmungen
                        grid.store.removeAll();

                        grid.store.add({
                            id : -3,
                            name : _('show all scenes'),
                            icon : null,
                            reachable : true,
                            checkable : true,
                            checked : record.get('checked')

                        });                       
                        grid.store.add({
                            id : -1,
                            name : '-',
                            icon : null,
                            reachable : true
                        });
                        oSceneStore.each(function(record) {
                            var oNewRecord = record.copy();
                            if (oNewRecord.get('reachable') || fChecked)
                                if (oNewRecord.get('id') < 64) {
                                    grid.store.add(oNewRecord);
                                    if (oNewRecord.get('id')==0) {
                                        if (groupID==2) {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:_('all closed'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        } else {
                                            oSceneControlStore.add({
                                                id:0,
                                                name:_('all off'),
                                                icon:oNewRecord.get('icon'),
                                                force:true
                                            });
                                        }
                                    }
                                }
                        });

                    }
                }
            }
            if (record.get('id')>=0) {               
                if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                    var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                    var groupID = this.parent.grids.lvlGroup.getSelectionModel().getSelection()[0].get('group');
                    if (zoneID != null) {
                        if (groupID != null) {
                        	if (groupID==48) {
	                            var oObject = {
		                                type : 'heating-mode',
		                                params : {
		                                    zone : zoneID,
		                                    mode : record.get('id')
		                                }
	                            };
	                            if (record.get('id')>32) {
	                            	oObject.params.mode=record.get('id')-32;
	                            	oObject.params.reset=true;
	                            }
                        	} else {
	                            var fForce = false;
	                            if (record.get('force')!=null)
	                                fForce=record.get('force');
	                            var oObject = {
	                                type : 'zone-scene',
	                                params : {
	                                    zone : zoneID,
	                                    group : groupID,
	                                    scene : record.get('id'),
	                                    force : fForce
	                                }
	                            };
                        	}
                            this.parent.setSelectedSubItem(oObject,true);
                        }
                    }
                }
            }
        });
        this.grids.lvlScene.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.macPanel.add(this.grids.lvlScene);

    },
    constructGridLvlRoom : function() {
        var oZoneControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'ZoneID', 'name' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oZoneStore = Ext.data.StoreManager.lookup('actionConfigurator_zoneStore');
        oZoneStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('ZoneID') != 0)
                oZoneControlStore.add(oNewRecord);
        });

        
        oZoneControlStore.add([{name:_('All zones'),ZoneID:0}]);
        oZoneControlStore.sort('name');        
        this.grids.lvlRoom = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oZoneControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table style="height:16px;width:100%"><tr><td width="100%">' + record.get('name') + '</td><td>&gt;</td></tr></table>';
                }
            } ]
        });

        this.grids.lvlRoom.parent = this;
        this.grids.lvlRoom.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                var zoneID = record.get('ZoneID');
                this.parent.constructGridLvlGroup(zoneID);
            } else if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 1) {
                var zoneID = record.get('ZoneID');
                this.parent.constructGridLvlDevice(zoneID);
            }
        });
        this.macPanel.add(this.grids.lvlRoom);
    },
    constructGridLvlHigh : function() {

        var oStore = Ext.create('Ext.data.Store', {
            fields : [ {name:'name',sortType:'asUCText'},'id' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });        
        if (dss.staticDataModel.HLECache!=null)
            if (dss.staticDataModel.HLECache.length>0) {
                for (var iIndex=0;iIndex<dss.staticDataModel.HLECache.length;iIndex++)
                    oStore.add( {   
                        name:dss.staticDataModel.HLECache[iIndex].name,
                        id:dss.staticDataModel.HLECache[iIndex].id
                    });
            }
        oStore.sort('name','ASC');
        this.grids.lvlHighLevelEvent = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            hideHeaders:true,
            viewConfig : {
                stripeRows : true
            },
            store : oStore,
            columns : [ {
                sortable : true,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : function(val, metadata, record, colIdx, store, view) {
                    return '<table><tr style="height:16px;"><td width="100%">' + record.get('name') + '</td></tr></table>';
                }
            } ]
        });
        this.grids.lvlHighLevelEvent.parent = this;
        this.macPanel.add(this.grids.lvlHighLevelEvent);

        this.grids.lvlHighLevelEvent.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.grids.lvlHighLevelEvent.on('itemclick', function(grid, record) {
            
            var oObject = {
                type : 'custom-event',
                params : {
                    event : record.get('id')
                }
            };
            this.parent.setSelectedSubItem(oObject,true);
        });

    },
    constructGridLvlURL : function() {

        this.grids.lvlURLText = Ext.create('Ext.form.field.Text', {
            xtype : 'textfield',
            name : 'url',
            margin : 5,
            fieldLabel : 'URL',
            allowBlank : false,
            blankText : _('This field is required'),
            invalidText : _('The value in this field is invalid'),
            labelWidth : 30,
            width : 614,
            enableKeyEvents: true,
            listeners: {
                keyup:function (edit) 
                {
                    edit.parent.oActualValue=null;
                    if (edit.isValid()) {
                        var oObject = {
                            type : 'url',
                            params : {
                                url : edit.getValue()
                            }
                        };
                        edit.parent.setSelectedSubItem(oObject,true);
                    }
                    edit.focus();
                }
            },
            valueToRaw : function (value)
            {
                if (value==null)
                    return "";
                value=value.replace(/&amp;/g, '&');
                return unescape(value);
            },
            rawToValue : function (value)
            {
                if (value =="")
                    return null;
                return escape(value);
            }
        });
        this.grids.lvlURL = Ext.create('Ext.panel.Panel', {
            height : this.iDefaultHeight,
            width : 624,
            autoScroll : true,
            items : [ this.grids.lvlURLText ]
        });

        this.grids.lvlURL.parent = this;
        this.grids.lvlURLText.parent = this;
        this.macPanel.add(this.grids.lvlURL);
    },
    constructGridLvlGroup : function(zoneID) {
        var oGroupControlStore = Ext.create('Ext.data.Store', {
            fields : [ 'id', 'group', 'name', 'icon', 'reachable' ],
            proxy : {
                type : 'memory',
                reader : {
                    type : 'json',
                    root : 'items'
                }
            }
        });

        var oGroupStore = this.getGroupStore(zoneID);
        oGroupStore.each(function(record) {
            var oNewRecord = record.copy();
            if (oNewRecord.get('reachable')) {
            	var fOK=true;
            	switch (oNewRecord.get('group')) {
            		case 0:
            		case 6:
            		case 7:
            		case 8:            			
            		case 16:            			
            		case 17:            			
            		case 18:            			
            		case 19:            			
            		case 20:            			
            		case 21:            			
            		case 22:            			
            		case 23:            			
            			fOK=false;
            			break;
            	}
            	
                if (fOK)
                    oGroupControlStore.add(oNewRecord);
                if (oNewRecord.get('group') == 1)
                    oGroupControlStore.add({
                        id : -1,
                        group : null,
                        name : oNewRecord.get('name') + _(' blinking'),
                        icon : dss.staticDataModel.baseImagePath + 'sceneIcons/scene_blink.png',
                        reachable : oNewRecord.get('reachable')
                    });
            }
        });
        oGroupControlStore.add({
            group : -1,
            name : '-',
            icon : null,
            reachable : true
        });

        var oSceneGroup0Store = null;
            //if (zoneID!=0) {
                oSceneGroup0Store = this.getSceneStore(zoneID, 0);
            /*} else {
                for (var iIndex=0;iIndex<dss.staticDataModel.getZoneArray().length;iIndex++) {
                    var firstZone=dss.staticDataModel.getZoneArray()[iIndex];
                    if (firstZone.ZoneID!=0) {                        
                        oSceneGroup0Store = this.getSceneStore(firstZone.ZoneID, 0);
                        iIndex=dss.staticDataModel.getZoneArray().length;
                    }
                }
            }*/
        if (oSceneGroup0Store!=null)
            oSceneGroup0Store.each(function(record) {
                var oNewRecord = record.copy();
                if (oNewRecord.get('reachable'))
                    oGroupControlStore.add(oNewRecord);
            });

        this.grids.lvlGroup = Ext.create('Ext.grid.Panel', {
            height : this.iDefaultHeight,
            width : this.iDefaultWidth,
            hideHeaders:true,
            autoScroll : true,
            viewConfig : {
                stripeRows : true
            },
            store : oGroupControlStore,
            columns : [ {
                sortable : false,
                hideable : false,
                dataIndex : 'name',
                flex : 1,
                renderer : this.defMacGridRenderer
            } ]
        });
        this.grids.lvlGroup.on('itemdblclick', function(grid, record) {
            if (this.parent.oActualValue !=null) {
                this.parent.macPanel.collapse();
            }
        });

        this.grids.lvlGroup.on('itemclick', function(grid, record) {
            this.parent.oActualValue=null;
            this.parent.macPanel.remove(this.parent.grids.lvlScene);
            if (this.parent.grids.lvl1.getSelectionModel().getSelection()[0].get('id') == 0) {
                var zoneID = this.parent.grids.lvlRoom.getSelectionModel().getSelection()[0].get('ZoneID');
                var groupID = record.get('group');
                if ((zoneID != null) && (groupID != null)) {
                    this.parent.constructGridLvlGroupScene(zoneID, groupID);
                } else {
                    if (record.get('id')!=null) {
                        if (record.get('id') < 0) {
                            var oObject = {
                                type : 'zone-blink',
                                params : {
                                    zone : zoneID,
                                    group : Math.abs(record.get('id'))
                                }
                            };                            
                            this.parent.setSelectedSubItem(oObject,true);
                        } else {
                            var oObject = {
                                type : 'zone-scene',
                                params : {
                                    zone : zoneID,
                                    group : 0,
                                    scene : record.get('id'),
                                    force : false
                                }
                            };
                            this.parent.setSelectedSubItem(oObject,true);
                        }
                    }
                }
            }
        });


        this.grids.lvlGroup.parent = this;
        this.macPanel.add(this.grids.lvlGroup);
    },
    constructMacGrids : function() {     
    	var me=this;


        var lvl1Store = Ext.data.StoreManager.lookup('actionConfigurator_l1Store');

        if (this.grids.lvl1== null) {
            var lvl1TempStore = Ext.create('Ext.data.Store', {
                fields : [ 'id', 'name', 'next', 'icon' ],
                proxy : {
                    type : 'memory',
                    reader : {
                        type : 'json',
                        root : 'items'
                    }
                }
            });
            lvl1Store.each(function(record) {
                var oNewRecord = record.copy();
                lvl1TempStore.add(oNewRecord);
            });
        	this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
	            height : this.iDefaultHeight,
	            width : this.iDefaultWidth,
	            hideHeaders:true,
	            autoScroll : true,
	            viewConfig : {
	                stripeRows : true
	            },
	            store : lvl1TempStore,
	            columns : [ {
	                sortable : false,
	                hideable : false,
	                dataIndex : 'name',
	                flex : 1,
	                renderer : this.defMacGridRenderer
	            } ]
	        });
	        this.grids.lvl1.parent = this;
	        this.grids.lvl1.on('itemdblclick', function(grid, record) {
	            if (this.parent.oActualValue !=null)
	                this.parent.macPanel.collapse();
	        });
	        
	        this.grids.lvl1.on('itemclick', function(grid, record) {
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceScene);
	            this.parent.macPanel.remove(this.parent.grids.lvlDeviceAction);
	            this.parent.macPanel.remove(this.parent.grids.lvlRoom);
	            this.parent.macPanel.remove(this.parent.grids.lvlHighLevelEvent);
	            this.parent.macPanel.remove(this.parent.grids.lvlURL);
	            this.parent.macPanel.remove(this.parent.grids.lvlGroup);
	            this.parent.macPanel.remove(this.parent.grids.lvlScene);
	            this.parent.macPanel.remove(this.parent.grids.lvlDevice);
	            this.parent.macPanel.remove(this.parent.grids.lvlWeather);
	            this.parent.macPanel.remove(this.parent.grids.lvlPanic);
	            this.parent.macPanel.remove(this.parent.grids.lvlAccess);
	            this.parent.macPanel.remove(this.parent.grids.lvlUserGroup);
	            this.parent.macPanel.remove(this.parent.grids.lvlUsergroupScene);
	            this.parent.macPanel.remove(this.parent.grids.lvlUserState);
	            this.parent.oActualValue =null;
	            var fIsPassive=false;
	            if (record.get('passive')!=null) {
	                if (record.get('passive')==true) {
	                    this.getSelectionModel().deselect(record);
	                    fIsPassive=true;
	                }
	            }
	            
	            if (!fIsPassive) {
	                if (record.get('id') == 0) {
	                    this.parent.constructGridLvlRoom();
	                } else if (record.get('id') == 1) {
	                    this.parent.constructGridLvlRoom();
	                } else if (record.get('id') == 2) {
	                    this.parent.constructGridLvlHigh();
	                } else if (record.get('id') == 3) {
	                    this.parent.constructGridLvlURL();
	                } else if (record.get('id') == 4) {
	                    this.parent.constructGridLvlAccess();
	                } else if (record.get('id') == 5) {
	                    this.parent.constructGridLvlWeather();
	                } else if (record.get('id') == 6) {
	                    this.parent.constructGridLvlPanic();
	                } else if (record.get('id') == 7) {
	                    this.parent.constructGridLvlUserGroup();
	                } else if (record.get('id') == 8) {
	                	this.parent.constructGridLvlUserState();
	                }                                
	                
	            } 
	            //me.updatePanelDescription();
	            this.parent.macPanel.doLayout();
	        });
        } else {
        	this.grids.lvl1.getStore().removeAll();
        	var mThis=this;
        	lvl1Store.each(function(record) {
                var oNewRecord = record.copy();
                mThis.grids.lvl1.getStore().add(oNewRecord);
            });
        	
        }
    },
    setSelectedSubItem : function(oObject,fNoMacgridRebuild) {
        this.oActualValue=oObject;
        if (this.getSelectedMainRecord() == null) {
            var oNewRecord=this.gridStore.add({
                pos : 0,
                action : oObject,
                delay:0
            });
            this.setSelectedMainRecord(this.gridStore.getCount()-1,fNoMacgridRebuild);
        } else {
            this.getSelectedMainRecord().set('action', oObject);
            this.getSelectedMainRecord().commit();
        }
        this.removeCls('myInvalid');
        this.mainGrid.doComponentLayout();
        if (!this.macPanel.collapsed)
        	this.updatePanelDescription();
    },
    setSelectedMainRecord: function(index,fNoMacgridRebuild) {
        if (this.fDelayEnabled)
            this.mainGrid.getSelectionModel().setCurrentPosition({row: index, column: 0});
        else
            this.mainGrid.getSelectionModel().select(index);
        if (fNoMacgridRebuild!=null)
        	if (fNoMacgridRebuild)
        		return;
        this.setMacGrid((this.getSelectedMainRecord()).get('action'));
    },
    getSelectedMainRecord: function() {
        if (this.fDelayEnabled) {
            if (this.mainGrid.getSelectionModel().getCurrentPosition()==null)
                return null;
            return this.mainGrid.getStore().getAt(this.mainGrid.getSelectionModel().getCurrentPosition().row);
        } else {
            if (this.mainGrid.getSelectionModel().getSelection()==null)
                return null;
            return this.mainGrid.getSelectionModel().getSelection()[0];
        }
    },
    deselectMainGrid:function() {
        var oldSelect=this.getSelectedMainRecord();
        if (oldSelect!=null) {
            if (this.fDelayEnabled) {
                this.mainGrid.getSelectionModel().setCurrentPosition(null);
            } else {
                this.mainGrid.getSelectionModel().deselect(oldSelect);
            }
        }
    },
    setMacGrid : function(oObject) {        
        this.macPanel.remove(this.grids.lvlDeviceScene);
        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlURL);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        this.macPanel.remove(this.grids.lvlWeather);
        this.macPanel.remove(this.grids.lvlPanic);
        this.macPanel.remove(this.grids.lvlAccess);
        this.macPanel.remove(this.grids.lvlUserGroup);
        this.macPanel.remove(this.grids.lvlUsergroupScene);
        this.macPanel.remove(this.grids.lvlUserState);

        this.oActualValue=oObject;
        if (oObject == null) {
            var oTempGrid = this.grids.lvl1;
            oTempGrid.store.removeAll();
            var lvl1Store = Ext.data.StoreManager.lookup('actionConfigurator_l1Store');
            lvl1Store.each(function(record) {
                var oNewRecord = record.copy();
                oTempGrid.store.add(oNewRecord);
            });
            this.grids.lvl1.getSelectionModel().deselectAll();
            //this.grids.lvl1.getSelectionModel().select(0);
            //this.constructGridLvlRoom();
        } else
            switch (oObject.type) {
	            case 'change-addon-state': {
            		if (oObject.params['addon-id']=='user-defined-states') {
                        if (this.fHighLevel)
                        	this.grids.lvl1.getSelectionModel().select(8);
                        else
                        	this.grids.lvl1.getSelectionModel().select(7);
            			this.constructGridLvlUserState();
                        var oRecordScene = this.grids.lvlUserState.store.find('id', oObject.params.statename.split('_')[1] + '_' + oObject.params.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlUserState.getSelectionModel().select(oRecordScene,true);            			
            		} 
	            	break;
	            }
            	case 'change-state':
            		// oAction.params.state
            		if (oObject.params.statename=='fire') {                		
                        if (this.fHighLevel)
                        	this.grids.lvl1.getSelectionModel().select(7);
                        else
                        	this.grids.lvl1.getSelectionModel().select(6);
                        this.constructGridLvlPanic();
                        
                        var oRecordScene = this.grids.lvlPanic.store.find('id', oObject.params.statename + '_' + oObject.params.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                	} else {
                        if (this.fHighLevel)
                        	this.grids.lvl1.getSelectionModel().select(6);
                        else
                        	this.grids.lvl1.getSelectionModel().select(5);
                        this.constructGridLvlWeather();
                		var oRecordScene = this.grids.lvlWeather.store.find('id', oObject.params.statename + '_' + oObject.params.state,0,false,false,true);
                        if (oRecordScene != -1)
                            this.grids.lvlWeather.getSelectionModel().select(oRecordScene,true);                		
                	}
            	break;
                case 'undo-zone-scene':
                    this.grids.lvl1.getSelectionModel().select(0);
                    if (oObject.params.zone == 0) {
                        var iSelectLVL1;
                        switch (oObject.params.scene) {
	                    	case 65:
	                    	case 76:
	                    	case 74:
	                    	case 83:
	                    	case 84:
	                    	case 85:
	                            if (this.fHighLevel)
	                            	this.grids.lvl1.getSelectionModel().select(7);
	                            else
	                            	this.grids.lvl1.getSelectionModel().select(6);
	                            this.constructGridLvlPanic();
	                    		var oRecordScene = this.grids.lvlPanic.store.find('id', 1000+oObject.params.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
	                            return;
	                    	break;	                    	
                        }
                    } 
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oObject.params.zone,0,false,false,true);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlGroup(oObject.params.zone);
                    if (oObject.params.group == 0) {
                        var oRecordGroup = this.grids.lvlGroup.store.find('id', oObject.params.scene,0,false,false,true);
                        if (oRecordGroup != -1)
                            this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                        else 
                            break;
                    } else {
                        var oRecordGroup = this.grids.lvlGroup.store.find('group', oObject.params.group,0,false,false,true);
                        if (oRecordGroup != -1)
                            this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                        else
                            break;
                        this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, false, oObject.params.force);

                        var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene,0,false,false,true);
                        if (oRecordScene != -1) {
                            if (oObject.params.force)
                                oRecordScene++;
                            this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                        } else {
                            this.macPanel.remove(this.grids.lvlScene);
                            this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, true, oObject.params.force);
                            var oRecordScene = this.grids.lvlScene.store.find('id', -1 * oObject.params.scene,0,false,false,true);
                            if (oRecordScene != -1) {
                                if (oObject.params.force)
                                    oRecordScene++;
                                this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                            }
                            else 
                                break;
                        }
                        if (oRecordScene > 11) {
                            var me = this;
                            var fn = function() {
                                me.grids.lvlScene.setScrollTop((oRecordScene) * 21);
                            };
                            window.setTimeout(fn, 10);
                        }

                        
                    }
                break;
                case 'heating-mode':
                	oObject.params.group=48;
                	oObject.params.scene=oObject.params.mode;
                	if (oObject.params.reset==true)
                		oObject.params.scene+=32;
                case 'zone-scene':
                    
                    if (oObject.params.zone == 0) {
                    	
                    	if ((oObject.params.group>15) && (oObject.params.group<24)) {
                			var iIndex = this.grids.lvl1.store.find('id', 7,0,false,false,true);
                            this.grids.lvl1.getSelectionModel().select(iIndex);
                            this.constructGridLvlUserGroup();
                            var oRecordGroup = this.grids.lvlUserGroup.store.find('id', oObject.params.group,0,false,false,true);
                            if (oRecordGroup != -1) {
                                this.grids.lvlUserGroup.getSelectionModel().select(oRecordGroup);
                                this.constructGridLvlUserGroupScene(oObject.params.group);

                                var oRecordScene = this.grids.lvlUsergroupScene.store.find('id', oObject.params.scene,0,false,false,true);
                                if (oRecordScene != -1) {
                                    if (oObject.params.force)
                                        oRecordScene++;
                                    this.grids.lvlUsergroupScene.getSelectionModel().select(oRecordScene);
                                } else {
                                    this.macPanel.remove(this.grids.lvlUsergroupScene);
                                    this.constructGridLvlUserGroupScene(oObject.params.group, true, oObject.params.force);
                                    var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene,0,false,false,true);
                                    if (oRecordScene != -1) {
                                        if (oObject.params.force)
                                            oRecordScene++;
                                        this.grids.lvlUsergroupScene.getSelectionModel().select(oRecordScene);
                                    }
                                    else 
                                        break;
                                }
                                if (oRecordScene > 11) {
                                    var me = this;
                                    var fn = function() {
                                        me.grids.lvlUsergroupScene.setScrollTop((oRecordScene) * 21);
                                    };
                                    window.setTimeout(fn, 10);
                                }
                            } 
                			break;
                    	} 
                    	
                        var iSelectLVL1;
                        switch (oObject.params.scene) {
	                    	case 65:
	                    	case 76:
	                    	case 74:
	                    	case 83:
	                    	case 84:
	                    	case 85:
	                            if (this.fHighLevel)
	                            	this.grids.lvl1.getSelectionModel().select(7);
	                            else
	                            	this.grids.lvl1.getSelectionModel().select(6);
	                            this.constructGridLvlPanic();
	                    		var oRecordScene = this.grids.lvlPanic.store.find('id', oObject.params.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlPanic.getSelectionModel().select(oRecordScene,true);
                                this.updatePanelDescription();
	                            return;
	                    	break;	    
	                    	case 88:
	                    	case 89:
	                    		if (this.fHighLevel)
	                            	this.grids.lvl1.getSelectionModel().select(6);
	                            else
	                            	this.grids.lvl1.getSelectionModel().select(5);
	                            this.constructGridLvlWeather();
	                    		var oRecordScene = this.grids.lvlWeather.store.find('id', oObject.params.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlWeather.getSelectionModel().select(oRecordScene,true);
                                this.updatePanelDescription();
	                            return;
	                        break;
	                    	case 73:
	                    	case 72:
	                    	case 71:
	                    		if (this.fHighLevel)
	                            	this.grids.lvl1.getSelectionModel().select(5);
	                            else
	                            	this.grids.lvl1.getSelectionModel().select(4);
	                            this.constructGridLvlAccess();
	                    		var oRecordScene = this.grids.lvlAccess.store.find('id', oObject.params.scene,0,false,false,true);
                                if (oRecordScene != -1)
                                    this.grids.lvlAccess.getSelectionModel().select(oRecordScene,true);
                                this.updatePanelDescription();
	                            return;
	                        break;
                        }                    	                       
                    } 
                    this.grids.lvl1.getSelectionModel().select(0);
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oObject.params.zone,0,false,false,true);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlGroup(oObject.params.zone);
                    if (oObject.params.group == 0) {
                        var oRecordGroup = this.grids.lvlGroup.store.find('id', oObject.params.scene,0,false,false,true);
                        if (oRecordGroup != -1)
                            this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                        else 
                            break;
                    } else {
                        var oRecordGroup = this.grids.lvlGroup.store.find('group', oObject.params.group,0,false,false,true);
                        if (oRecordGroup != -1)
                            this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                        else
                            break;
                        this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, false, oObject.params.force);

                        var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene,0,false,false,true);
                        if (oRecordScene != -1) {
                            if (oObject.params.force)
                                oRecordScene++;
                            this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                        } else {
                            this.macPanel.remove(this.grids.lvlScene);
                            this.constructGridLvlGroupScene(oObject.params.zone, oObject.params.group, true, oObject.params.force);
                            var oRecordScene = this.grids.lvlScene.store.find('id', oObject.params.scene,0,false,false,true);
                            if (oRecordScene != -1) {
                                if (oObject.params.force)
                                    oRecordScene++;
                                this.grids.lvlScene.getSelectionModel().select(oRecordScene);
                            }
                            else 
                                break;
                        }
                        if (oRecordScene > 11) {
                            var me = this;
                            var fn = function() {
                                me.grids.lvlScene.setScrollTop((oRecordScene) * 21);
                            };
                            window.setTimeout(fn, 10);
                        }                
                    }
                break;
                case 'device-scene':
                    this.grids.lvl1.getSelectionModel().select(1);
                    var zoneID = dss.staticDataModel.getDevice(oObject.params.dsuid).ZoneID;
                    var groupID = dss.staticDataModel.getDevice(oObject.params.dsuid).GroupID;
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID,0,false,false,true);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlDevice(zoneID);
                    var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oObject.params.dsuid,0,false,false,true);
                    if (oRecordDevice != -1)
                        this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                    else
                        break;
                    this.constructGridLvlDeviceActions(oObject.params.dsuid);
                    if (oObject.params.scene == 13) { // id:1
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 1,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else if (oObject.params.scene == 14) { // id:2
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 2,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else if (oObject.params.scene == 51) { // id:3
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 3,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                    } else {
                        var iIndex = this.grids.lvlDeviceAction.store.find('id', 5,0,false,false,true);
                        if (iIndex!=-1)
                            this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                        else 
                            break;
                        this.constructGridLvlDeviceScene(zoneID, groupID);

                        var oRecordScene = this.grids.lvlDeviceScene.store.find('id', oObject.params.scene,0,false,false,true);
                        if (oRecordScene != -1) {
                            if (oObject.params.force)
                                oRecordScene++;
                            this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);
                        } else {
                            this.macPanel.remove(this.grids.lvlDeviceScene);
                            this.constructGridLvlDeviceScene(oObject.params.zone, oObject.params.group, true, oObject.params.force);
                            var oRecordScene = this.grids.lvlDeviceScene.store.find('id', oObject.params.scene,0,false,false,true);
                            if (oRecordScene != -1) {
                                if (oObject.params.force)
                                    oRecordScene++;
                                this.grids.lvlDeviceScene.getSelectionModel().select(oRecordScene);
                            }
                        }
                        if (oRecordScene > 11) {
                            var me = this;
                            var fn = function() {
                                me.grids.lvlDeviceScene.setScrollTop((oRecordScene) * 21);
                            };
                            window.setTimeout(fn, 10);
                        }

                    }
                break;
                case 'device-value':
                    // nicht unterstuetzt aktuell
                break;
                case 'device-blink':
                    this.grids.lvl1.getSelectionModel().select(1);
                    var zoneID = dss.staticDataModel.getDevice(oObject.params.dsuid).ZoneID;
                    var groupID = dss.staticDataModel.getDevice(oObject.params.dsuid).GroupID;
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', zoneID,0,false,false,true);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else 
                        break;
                    this.constructGridLvlDevice(zoneID);
                    var oRecordDevice = this.grids.lvlDevice.store.find('dSUID', oObject.params.dsuid,0,false,false,true);
                    if (oRecordDevice != -1)
                        this.grids.lvlDevice.getSelectionModel().select(oRecordDevice);
                    else
                        break;
                    this.constructGridLvlDeviceActions(oObject.params.dsuid);
                    var iIndex = this.grids.lvlDeviceAction.store.find('id', 4,0,false,false,true);
                    if (iIndex!=-1)
                        this.grids.lvlDeviceAction.getSelectionModel().select(iIndex);
                break;
                case 'zone-blink':
                	if (oObject.params.zone==0)
                		if ((oObject.params.group>15) && (oObject.params.group<24)) {
                			var iIndex = this.grids.lvl1.store.find('id', 7,0,false,false,true);
                            this.grids.lvl1.getSelectionModel().select(iIndex);
                            this.constructGridLvlUserGroup();
                            var oRecordZone = this.grids.lvlUserGroup.store.find('id', -1 * oObject.params.group,0,false,false,true);
                            if (oRecordZone != -1)
                                this.grids.lvlUserGroup.getSelectionModel().select(oRecordZone);
                            else
                                break;                            
                			break;
                		}
                	
                    this.grids.lvl1.getSelectionModel().select(0);
                    this.constructGridLvlRoom();
                    var oRecordZone = this.grids.lvlRoom.store.find('ZoneID', oObject.params.zone,0,false,false,true);
                    if (oRecordZone != -1)
                        this.grids.lvlRoom.getSelectionModel().select(oRecordZone);
                    else
                        break;
                    this.constructGridLvlGroup(oObject.params.zone);
                    var oRecordGroup = this.grids.lvlGroup.store.find('id', -1 * oObject.params.group,0,false,false,true);
                    if (oRecordGroup != -1)
                        this.grids.lvlGroup.getSelectionModel().select(oRecordGroup);
                    else
                        break;
                break;
                case 'custom-event':
                    this.grids.lvl1.getSelectionModel().select(2);
                    this.constructGridLvlHigh();
                    var oRecord = this.grids.lvlHighLevelEvent.store.find('id', oObject.params.event,0,false,false,true);
                    if (oRecord != -1)
                        this.grids.lvlHighLevelEvent.getSelectionModel().select(oRecord);
                break;
                case 'url':
                    if (this.fHighLevel)
                        this.grids.lvl1.getSelectionModel().select(3);
                    else
                        this.grids.lvl1.getSelectionModel().select(2);
                    this.constructGridLvlURL();
                    this.grids.lvlURLText.setValue(oObject.params.url);
                break;
            }
        this.updatePanelDescription();
    },
    eventHandlerSelectionChange : function (view, selections, options) {
        var mThis=this;
        if (this.parent!=null)
            mThis=this.parent;
        if (selections.length > 0) {
            mThis.oButtonEdit.setDisabled(false);
            mThis.oButtonDelete.setDisabled(false);
            var selIndex = -1;
            for ( var iIndex = 0; iIndex < view.store.getCount(); iIndex++) {
                if (view.store.getAt(iIndex) == selections[0])
                    selIndex = iIndex;
            }
            mThis.oButtonUp.setDisabled(selIndex == 0);
            mThis.oButtonDown.setDisabled(selIndex == (view.store.getCount() - 1));
            var iIndex = mThis.mainGrid.store.indexOf(selections[0]);
            mThis.lblSelectorAnzeige.setText(Ext.String.format2(_('activity {index}/{count}'),{index:''+(iIndex + 1),count:''+view.store.getCount()}),false);
        } else {
            mThis.oButtonEdit.setDisabled(true);
            mThis.oButtonDelete.setDisabled(true);
            mThis.oButtonUp.setDisabled(true);
            mThis.oButtonDown.setDisabled(true);
            if (view.store.getCount()==0)
                mThis.lblSelectorAnzeige.setText(_('no activity'),false);
            else if (view.store.getCount()==1)
                mThis.lblSelectorAnzeige.setText(_('1 activity'),false);
            else
                mThis.lblSelectorAnzeige.setText('' + view.store.getCount() + _(' activites'),false);
        }
    },
    constructor : function(config) {
        Ext.tip.QuickTipManager.init();
        var mThis=this;
        this.fHighLevel=true;
        this.fEnableUsergroup=false;
        this.fIgnorePresence=false;
        if (config.ignorePresence!=null)
        	this.fIgnorePresence=config.ignorePresence;
        this.fHeatingOperationMode=false;
        if (config.heatingOperationMode!=null)
        	this.fHeatingOperationMode=config.heatingOperationMode;
        if (config.noHighlevel!=null)
            if (config.noHighlevel)
                this.fHighLevel=false;
        
        this.fUserstates=false;
        if (config.userStates!=null)
        	this.fUserstates=config.userStates;
        
        this.fDelayEnabled=false;
        if (config.withDelay!=null)
            this.fDelayEnabled=config.withDelay;
        if (config.allowNoAction!=null)
        	this.fAllowNoAction=config.allowNoAction;
        if (config.enableUsergroup!=null)
        	this.fEnableUsergroup=config.enableUsergroup;
        
        this.initStores(this.fHighLevel,this.fUserstates);        
        this.initGridStore();
        Ext.data.StoreManager.on('clear',function () {mThis.initStores(mThis.fHighLevel, mThis.fUserstates);mThis.constructMacGrids();});

        this.constructMacGrids();
        this.lblSelectorAnzeige = Ext.create('Ext.form.Label', {
            width : 200,
            height : 22,
            padding : 4,
            style : {
                textAlign : 'right'
            }
        });

        this.oButtonNew = Ext.create('Ext.button.Button', {
            iconCls : 'icon-add-action',
            text : _('new activity'),
            handler : function() {
                this.parent.oActualValue=null;
                if (this.parent.macPanel.collapsed)
                	this.parent.macPanel.expand(true);
                else
                	this.parent.setMacGrid();
                this.parent.deselectMainGrid();
            }
        });
        this.oButtonNew.parent = this;

        this.oButtonEdit = Ext.create('Ext.button.Button', {
            iconCls : 'icon-edit-action',
            text : _('edit activity'),
            disabled : true,
            handler : function() {
                if (this.parent.macPanel.collapsed) {
                	this.parent.oActualValue=this.parent.getSelectedMainRecord().get('action');
                	this.parent.macPanel.expand(true);                    
                    //this.parent.setMacGrid(this.parent.oActualValue);
                } else {
                    this.parent.macPanel.collapse();                    
                }
            }
        });
        this.oButtonEdit.parent = this;

        this.oButtonUp = Ext.create('Ext.button.Button', {
            iconCls : 'icon-left-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex - 1);
            }
        });
        this.oButtonUp.parent = this;

        this.oButtonDown = Ext.create('Ext.button.Button', {
            iconCls : 'icon-right-action',
            disabled : true,
            handler : function() {
                var iIndex = this.parent.mainGrid.store.indexOf(this.parent.getSelectedMainRecord());
                mThis.setSelectedMainRecord(iIndex + 1);
            }
        });
        this.oButtonDown.parent = this;

        this.oButtonDelete = Ext.create('Ext.button.Button', {
            iconCls : 'icon-delete-action',
            tooltip:  _('delete activity'),
            disabled : true,
            handler : function() {
                this.parent.macPanel.collapse();
                this.parent.gridStore.remove(this.parent.getSelectedMainRecord());
            }
        });
        this.oButtonDelete.parent = this;

        if (this.fDelayEnabled) { 
            var selModel=Ext.create('Ext.selection.CellModel',
                    {allowDeselect:true,
                     mode:'SINGLE'});

            var cellEditing = Ext.create('Ext.grid.plugin.CellEditing', {clicksToEdit : 1 });

            this.mainGrid = Ext.create('Ext.grid.Panel', {
                enableColumnHide : false,
                enableColumnMove : false,
                selType : 'cellmodel',
                border : '0',
                region : 'center',
                height : "100%",
                store : this.gridStore,
                hideHeaders : true,
                overflowX:'hidden',                
                plugins : [ cellEditing ],
                width:772,
                viewConfig : {
                    stripeRows : true
                },
                //selModel : selModel,
                columns : [ {
                    header : _('action'),
                    dataIndex : 'action',
                    sortable : false,
                    hideable : false,
                    width:654,
                    renderer : this.defMainGridRenderer
                } ,{
                    header : _('delay'),
                    dataIndex : 'delay',
                    sortable : false,
                    hideable : false,
                    width:100,
                    renderer: function(val, metadata, record, colIdx, store, view) {
                    	if (record.get('delay')==null)
                            return _('without delay');
                    	else
	                        if (record.get('delay')==0)
	                            return _('without delay');
	                        else
	                            return (record.get('delay')) + ' ' +  _('minutes');
                    },
                    editor : {
                        xtype : 'numberfield',
                        allowBlank : false,
                        blankText : _('This field is required'),
                        invalidText : _('The value in this field is invalid'),
                        minValue : 0,
                        maxValue : (24*60)
                    }
                } ],
                tbar : [ this.oButtonNew, this.oButtonEdit,
                // { xtype: 'button', text: 'Erweiterte Ansicht',
                // id: 'action-selector-btn-extended' ,
                // disabled:true},
                '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
            });
            this.mainGrid.getSelectionModel().addListener('select',function(grid,record,row,column) {
                mThis.eventHandlerSelectionChange(mThis.mainGrid,[record]);
            });
        } else {
            this.mainGrid = Ext.create('Ext.grid.Panel', {
                enableColumnHide : false,
                enableColumnMove : false,
                selType : 'rowmodel',
                border : '0',
                region : 'center',
                //height : "100%",
                store : this.gridStore,
                hideHeaders : true,
                overflowX:'hidden',                
                columns : [ {
                    header : _('action'),
                    dataIndex : 'action',
                    sortable : false,
                    hideable : false,
                    width:754,
                    renderer : this.defMainGridRenderer
                } ],
                tbar : [ this.oButtonNew, this.oButtonEdit,
                // { xtype: 'button', text: 'Erweiterte Ansicht',
                // id: 'action-selector-btn-extended' ,
                // disabled:true},
                '->', this.lblSelectorAnzeige, this.oButtonUp, this.oButtonDown, this.oButtonDelete ]
            });
        }
        this.mainGrid.parent = this;
        this.mainGrid.on({
            selectionchange : this.eventHandlerSelectionChange,
            edit: function(editor, eventObject) {
                this.parent.gridStore.sort('delay','ASC');
            },
            itemdblclick : function(grid, record,item,index,e) {
                this.parent.oActualValue=(this.parent.getSelectedMainRecord()).get('action');
            	this.parent.macPanel.expand(true);
            }
        });
        this.macPanel = Ext.create('Ext.panel.Panel', {
            border : '0',
            region : 'south',
            title : _('show activity editor'),
            collapsible : true,
            collapsed : false,
            autoScroll : true,
            animCollapse : true,
            height : 320,
            layout : {
                type : 'hbox'
            },
            items : [ this.grids.lvl1 ],
            listeners : {
            	beforecollapse : function(pPanel) {
            		pPanel.up().setMacGrid();
            		pPanel.setTitle('');
            	},
                collapse : function(pPanel) {
                	pPanel.setTitle('');
                	mThis.oButtonEdit.setDisabled(pPanel.up().getSelectedMainRecord()==null);
                	mThis.oButtonEdit.setText(_('edit activity'));
                	mThis.doLayout();                	
                 },
                expand : function(pPanel) {
                	pPanel.up().updatePanelDescription();
                	mThis.oButtonEdit.setDisabled(false);
                	mThis.oButtonEdit.setText(_('show all activities'));
                	mThis.doLayout();
                	mThis.setMacGrid(mThis.oActualValue);
                }
            },
            scroll : 'horizontal'

        });

        Ext.apply(this, {
            items : [ this.mainGrid, this.macPanel ]
        });
        defbug=this;
        this.callParent(arguments);
        this.on('updatePanelDescription',this._updatePanelDescription,this);
    },
    reset : function() {
        this.setValue(null);
    },
    tabChange : function(fActive) {
        
    }, 
    setValue : function(values) {
        this.macPanel.remove(this.grids.lvlDeviceScene);
        this.macPanel.remove(this.grids.lvlDeviceAction);
        this.macPanel.remove(this.grids.lvlRoom);
        this.macPanel.remove(this.grids.lvlHighLevelEvent);
        this.macPanel.remove(this.grids.lvlURL);
        this.macPanel.remove(this.grids.lvlGroup);
        this.macPanel.remove(this.grids.lvlScene);
        this.macPanel.remove(this.grids.lvlDevice);
        this.macPanel.remove(this.grids.lvlUserGroup);
        this.macPanel.remove(this.grids.lvlUsergroupScene);
        this.macPanel.remove(this.grids.lvlUserState);

        var me = this;
        this.removeCls('myInvalid');
        if (values == null) {
        	for (var iIndex=this.gridStore.getCount();iIndex>0;iIndex--) {
	        	try {
	                this.gridStore.removeAt(iIndex-1); 
	            } catch (e) {}
        	}
            this.doLayout();
            this.macPanel.expand(false);
            this.oButtonEdit.setText(_('show all activities'));
            this.lblSelectorAnzeige.setText(_('no activity'),false);
            this.setMacGrid();
        } else {
        	for (var iIndex=this.gridStore.getCount();iIndex>0;iIndex--) {
	        	try {
	                this.gridStore.removeAt(iIndex-1); 
	            } catch (e) {}
        	}
            for ( var iIndex = 0; iIndex < values.length; iIndex++) {
                var oObject = {
                    type : values[iIndex].type,
                    params : {}
                };
                var delay = 0;
                for ( var sKey in values[iIndex]) {
                    if (sKey != "type")
                        oObject.params[sKey] = values[iIndex][sKey];
                    if (sKey == "delay")
                        delay = parseInt(""+values[iIndex][sKey],10)/60;
                }
                
                if (delay==null)
                	delay=0;
                try {
	                this.gridStore.add({
	                    action : oObject,
	                    delay : delay
	                });
                } catch (e) {}
            }
            this.setSelectedMainRecord(0);
            this.doLayout();
            if (values.length==1) {
                this.oActualValue=(this.getSelectedMainRecord()).get('action');
            	this.macPanel.expand(false);
            	this.oButtonEdit.setText(_('show all activities'));
            	this.setMacGrid(this.oActualValue);
            }
            else  {
            	this.macPanel.collapse(false);
            	this.oButtonEdit.setText(_('edit activity'));
                this.setMacGrid();
            }
        }
    },
    isValid : function() {
        var valid = (this.gridStore.getCount() > 0) || this.fAllowNoAction;
        this.gridStore.each(function(record) {
            if (record.get('action').type==null)
                valid=false;
            else if (record.get('action').type=="undefined")
                valid=false;
            else if (record.get('action').type=="zone-value")
                valid=false;
            else if (record.get('action').type=="undo-zone-value")
                valid=false;
            else if (record.get('action').type=="device-value")
                valid=false;
        }); 
                
        if (valid)
            this.removeCls('myInvalid');
        else
            this.addCls('myInvalid');
        return valid;
    },
    getValue : function() {
        var oResult = [];
        this.gridStore.each(function(record) {
            var oObject = {};
            var oRecord = record.get('action');
            var oDelay = record.get('delay');
            oObject.type = oRecord.type;
            for ( var oKey in oRecord.params) {
                oObject[oKey] = oRecord.params[oKey];
            }
            if (oDelay!=null)
                oObject.delay=oDelay*60;
            else
                oObject.delay=0;
            oResult.push(oObject);
        });
        return oResult;
    }
}); // DSS.component.ActionConfigurator

var defbug;
